// this example copies the DACL and SACL of a source file
// to a target file

#define STRICT
#define BUFSIZE 65536+SECURITY_DESCRIPTOR_MIN_LENGTH
#include <windows.h>
#include <stdio.h>

int main(int argc, char **argv)
{
    LPSTR sourcefile, targetfile;
    UCHAR ucBuf[BUFSIZE]="";
    DWORD dwSDLength=BUFSIZE;
    DWORD dwSDLengthNeeded;
    PSECURITY_DESCRIPTOR psdSD = (PSECURITY_DESCRIPTOR)&ucBuf;
    HKEY hKey;

    if ( argc != 3 ) {
	fprintf(stderr,"usage %s file1 file2\n",argv[0]);
	return 3;
	}

    sourcefile=argv[1];
    targetfile=argv[2];
    
    if (!GetFileSecurity(sourcefile,
                         DACL_SECURITY_INFORMATION,
                         psdSD,
                         dwSDLength, 
                         (LPDWORD)&dwSDLengthNeeded)) {
        printf("Error getting file DACL\n");
        return 1;
    }

    if (!SetFileSecurity(targetfile,
                         DACL_SECURITY_INFORMATION,
                         psdSD)) {
        printf("Error setting file DACL\n");
        return 2;
    }

    return 0;
}
